/*******************************************************************************
Copyright (C) 1991 OMRON Corporation and KEIO University
See COPYRIGHT for details.
t@C: yumimain.c
W[ ID : 0.0
W[ : main
@\Tv: uTq搶vC
쐬: jY
XV: scrFAB
ANSIΉ: 悤߂
WinNTڐA: 悤߂

*******************************************************************************/



#ifndef _WIN32

#ifdef	NO_CURSES
#include	<sys/ioctl.h>
#include	<stdio.h>
#else  !NO_CURSES
#include	<curses.h>
#endif	NO_CURSES
#ifdef	PCAT
#include	<sys/termios.h>
#endif	PCAT

#else 

#include <stdio.h>
#include <windows.h>
#include <time.h>
#define NO_CURSES

#endif _WIN32



#include	"yumihead.h"


int keyboard = KEYBOARD_LUNA;

#define KANJI_JIS	1
#define KANJI_UJIS	2
#define KANJI_SJIS	3
int kanji_code = KANJI_SJIS;

char *program;

int int_flag = FALSE;

void main (int argc,char* argv[])
{
	extern void interrupt();
	char *menu;

	program = argv[0];
	argc--;
	argv++;
	menu = "root";
	while (argc > 0) {
		if (strcmp(argv[0], "luna") == 0) {
			keyboard = KEYBOARD_LUNA;
		}
		else if (strcmp(argv[0], "news") == 0) {
			keyboard = KEYBOARD_NEWS;
		}
		else if (strcmp(argv[0], "jis") == 0) {
			kanji_code = KANJI_JIS;
		}
		else if (strcmp(argv[0], "ujis") == 0) {
			kanji_code = KANJI_UJIS;
		}
		else if (strcmp(argv[0], "sjis") == 0) {
			kanji_code = KANJI_SJIS;
		}
		else {
			menu = argv[0];
		}
		argc--;
		argv++;
	}

	/* initialize curses */
	if (init_term() != OK) {
		fputs("Sorry, I can't run on your terminal.\r\n", stderr);
		finish(1);
	}

	menu_main(menu);
	finish(0);
}

int init_term(void)
{
	char	*getenv();
	/*char	*p;*/

	if (initscr() == ERR) {
		fputs("Terminal is too dumb.\r\n", stderr);
		return (ERR);
	}
	raw();
	nonl();
	noecho();

	if (LINES < 24 || COLS < 80) {
		fputs("Terminal size has to be larger than 80 columns x 24 lines.\r\n", stderr);
		return (ERR);
	}
	else
		return (OK);
}


void finish(int ret)
{
	move(LINES - 1, 0);
	refresh();
	nl();
	echo();
	noraw();
	endwin();
	exit(ret);
}

#ifdef	NO_CURSES
void sfc_getstr(char buf[],int max)
{
	int cx, cy;
	int c, ch;

	cx = curx;
	cy = cury;
	c = 0;
	refresh();
	while ((ch = getch()) != EOF) {
		switch (ch) {
		      case '\n':
		      case '\r':
			buf[c] = 0;
			return;
		      case 'U'-'@':
			if (c > 0) {
				cx -= c;
				c = 0;
				move(cy,cx);
				clrtoeol();
			}
			break;
		      case 'H'-'@':
		      case 0x7f:
			if (c > 0) {
				c--;
				cx--;
				move(cy,cx);
				clrtoeol();
			}
			break;
		      default:
			if (ch >= ' ' && c < max-1) {
				buf[c++] = ch;
				addch((char)ch);
				cx++;
				move(cy,cx);
			}
			break;
		}
		refresh();
	}
	buf[c] = 0;
	return;
}

/* SFC version curses(?) emulation routines */

#ifndef _WIN32

#ifdef	PCAT
struct	termios savets, ts;
#else  !PCAT
struct	sgttyb	savemode;
struct	ltchars	savelt;
struct  tchars savetc;
int	tflags;
#endif	PCAT

#endif _WIN32

char term_buf[1024];
char cap_buf[2048];
char *cap_buf_p;
/*int LINES, COLS;*/
char *CM, *CL, *SO, *SE, *UE, *US, *CE, *VB;
int curx, cury;
int kanji_jis_mode = 0;

#ifdef _IBMR2
union txname savedtx;
char strBSD[] = "bsd";
#endif

void kanji_in(void)
{
	if (!kanji_jis_mode) {
		kanji_jis_mode = TRUE;
		printf("%c$@", 27);
	}
}

void kanji_out(void)
{
	if (kanji_jis_mode) {
		kanji_jis_mode = FALSE;
		printf("%c(J", 27);
	}
}

void kanji_put(int ch1,int ch2)
{
	switch (kanji_code) {
	case KANJI_UJIS:
		putchar(ch1 | 0x80);
		putchar(ch2 | 0x80);
		break;
	case KANJI_SJIS:
		if (ch1 <= 0x5e) putchar((ch1-1)/2+0x71);
		else putchar((ch1-1)/2+0xb1);
		if (ch1 & 1) {
			if (ch2 >= 0x60) putchar(ch2+0x20);
			else putchar(ch2+0x1f);
		}
		else putchar(ch2+0x7e);
		break;
	case KANJI_JIS:
	default:
		kanji_in();
		putchar(ch1);
		putchar(ch2);
		break;
	}
}

int  _putchar(char c)
{
	return putchar(c);
}

int initscr(void)
{
#ifndef _WIN32


	char *tgetstr();

#ifdef _IBMR2
	savedtx.tx_which = 0;
	ioctl(0, TXGETLD, &savedtx);
	if (strcmp(savedtx.tx_name, strBSD) != 0) {
	    ioctl(0, TXSETLD, strBSD);
	}
#endif
#ifdef	PCAT
	ioctl(0, TIOCGETA, &savets);
	ts = savets;
#else  !PCAT
	ioctl(0, TIOCGETC, &savetc);
	ioctl(0, TIOCGLTC, &savelt);
	ioctl(0, TIOCGETP, &savemode);
	tflags = savemode.sg_flags;
#endif	PCAT
	if (tgetent(term_buf, getenv("TERM")) != 1)
	  return ERR;
	cap_buf_p = cap_buf;
	LINES = tgetnum("li");
	COLS = tgetnum("co");
	if ((CM = tgetstr("cm", &cap_buf_p)) == NULL) return ERR;
	if ((CL = tgetstr("cl", &cap_buf_p)) == NULL) return ERR;
	if ((SO = tgetstr("so", &cap_buf_p)) == NULL) return ERR;
	if ((SE = tgetstr("se", &cap_buf_p)) == NULL) return ERR;
	if ((CE = tgetstr("ce", &cap_buf_p)) == NULL) return ERR;
	US = tgetstr("us", &cap_buf_p);
	UE = tgetstr("ue", &cap_buf_p);
	VB = tgetstr("vb", &cap_buf_p);
	clear();
	return OK;

#endif _WIN32


	return OK;
}

int endwin(void)
{
	kanji_out();
	return OK;
}

void raw(void)
{
#ifndef _WIN32

#ifdef	PCAT
	int i;
	
	ts.c_iflag = 0;
	ts.c_oflag = 0;
	ts.c_lflag = ISIG;
	for (i = 0; i < NCCS; i++) ts.c_cc[i] = 0;
	ts.c_cc[VINTR] = 'C'-'@';
	ioctl(0, TIOCSETA, &ts);
#else  !PCAT
	struct	sgttyb	t;
	struct	ltchars	lt;
	struct  tchars tc;

	tc = savetc;
	tc.t_startc = tc.t_stopc = tc.t_eofc = tc.t_brkc = tc.t_quitc = -1;
	tc.t_intrc = 'C'-'@';
	ioctl(0, TIOCSETC, &tc);
	lt = savelt;
	lt.t_suspc = lt.t_dsuspc = lt.t_rprntc = lt.t_flushc = lt.t_werasc = lt.t_lnextc = -1;
	ioctl(0, TIOCSLTC, &lt);
	t = savemode;
	tflags |= CBREAK;
	tflags &= ~(RAW|XTABS);
	t.sg_flags = tflags;
	ioctl(0, TIOCSETP, &t);
#endif	PCAT

#endif _WIN32
}

void noraw(void)
{
#ifndef _WIN32

#ifdef	PCAT
	ioctl(0, TIOCSETA, &savets);
#else  !PCAT
	ioctl(0, TIOCSETC, &savetc);
	ioctl(0, TIOCSLTC, &savelt);
	ioctl(0, TIOCSETP, &savemode);
#ifdef _IBMR2
	ioctl(0, TXSETLD, &savedtx);
#endif
#endif	PCAT

#endif _WIN32
}

void nl(void)
{
#ifndef _WIN32

#ifdef	PCAT
	ts.c_iflag |= ICRNL;
	ioctl(0, TIOCSETA, &ts);
#else  !PCAT
	struct sgttyb t;

	t = savemode;
	tflags |= CRMOD;
	t.sg_flags = tflags;
	ioctl(0, TIOCSETP, &t);
#endif	PCAT

#endif _WIN32
}

void nonl(void)
{
#ifndef _WIN32

#ifdef	PCAT
	ts.c_iflag &= ~ICRNL;
	ioctl(0, TIOCSETA, &ts);
#else  !PCAT
	struct sgttyb t;

	t = savemode;
	tflags &= ~CRMOD;
	t.sg_flags = tflags;
	ioctl(0, TIOCSETP, &t);
#endif	PCAT

#endif _WIN32
}

void echo(void)
{
#ifndef _WIN32

#ifdef	PCAT
	ts.c_lflag |= ECHO;
	ioctl(0, TIOCSETA, &ts);
#else  !PCAT
	struct sgttyb t;

	t = savemode;
	tflags |= ECHO;
	t.sg_flags = tflags;
	ioctl(0, TIOCSETP, &t);
#endif	PCAT

#endif _WIN32
}

void noecho(void)
{
#ifndef _WIN32

#ifdef	PCAT
	ts.c_lflag &= ~ECHO;
	ioctl(0, TIOCSETA, &ts);
#else  !PCAT
	struct sgttyb t;

	t = savemode;
	tflags &= ~ECHO;
	t.sg_flags = tflags;
	ioctl(0, TIOCSETP, &t);
#endif	PCAT

#endif _WIN32
}

void refresh(void)
{
	kanji_out();
	fflush(stdout);
}

void mvprintw(int y,int x,char* fmt,int a0,int a1,int a2,int a3,int a4,int a5,int a6,int a7)
{
	char buf[512], buf2[512];
	char *p, *q;
	int kanji, ch;

	kanji = 0;
	p = fmt;
	q = buf;
	while (ch = *p++) {
		if (ch == 27) /* ESC */ {
			kanji = !kanji;
		}
		else if (ch == '%' && kanji) {
			*q++ = '%';
		}
		*q++ = ch;
	}
	*q = 0;
	sprintf(buf2, buf, a0, a1, a2, a3, a4, a5, a6, a7);
	mvaddstr(y, x, buf2);
}

void standout(void)
{
	kanji_out();

#ifndef _WIN32
	tputs(SO, 0, _putchar);
#endif _WIN32
}

void standend(void)
{
	kanji_out();
#ifndef _WIN32
	tputs(SE, 0, _putchar);
#endif _WIN32
}

void standout2(void)
{
#ifdef _WIN32
	HANDLE ho;
#endif
	kanji_out();

#ifndef _WIN32
	tputs(SO, 0, _putchar);
#endif _WIN32

#ifdef _WIN32
	ho=GetStdHandle(STD_OUTPUT_HANDLE);
	SetConsoleTextAttribute(ho,BACKGROUND_BLUE | BACKGROUND_GREEN | BACKGROUND_RED);
#endif
}

void standend2(void)
{
#ifdef _WIN32
	HANDLE ho;
#endif
	kanji_out();
#ifndef _WIN32
	tputs(SE, 0, _putchar);
#endif _WIN32
#ifdef _WIN32
	ho=GetStdHandle(STD_OUTPUT_HANDLE);
	SetConsoleTextAttribute(ho,FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE );
#endif
}

void move(int y,int x)
{
#ifndef _WIN32
	if (curx == x && cury == y) return;
	kanji_out();
	cury = y;
	curx = x;
	tputs(tgoto(CM, x, y), 0, _putchar);
#else

	HANDLE ho;
    COORD      co;
	co.X=x;
	co.Y=y;
	ho=GetStdHandle(STD_OUTPUT_HANDLE);
	SetConsoleCursorPosition(ho,co);

#endif _WIN32
}

void printw(char *fmt,int a0,int a1,int a2,int a3,int a4,int a5,int a6,int a7)
{
	char buf[512];

	sprintf(buf, fmt, a0, a1, a2, a3, a4, a5, a6, a7);
	addstr(buf);
}

void mvaddstr(int y,int  x,char *p)
{
	move(y, x);
	addstr(p);
}

void mvaddch(int y,int  x,char ch)
{
	move(y, x);
	addch(ch);
}

void addstr(char*p)
{
	char ch;

	while (ch = *p++) addch(ch);
}

void attrset(int ul)
{
#ifndef _WIN32
	if (ul == A_UNDERLINE) {
		if (US) {
			kanji_out();
			tputs(US, 0, _putchar);
		}
	}
	else if (UE) {
		kanji_out();
		tputs(UE, 0, _putchar);
	}
#endif _WIN32

}

void clear(void)
{
#ifndef _WIN32
	curx = cury = 0;
	kanji_out();
	tputs(CL, 0, _putchar);
#else

	HANDLE ho;
	DWORD l;
	CONSOLE_SCREEN_BUFFER_INFO cbi;
    COORD      co;
	int sz;

	co.X=0;
	co.Y=0;

	ho=GetStdHandle(STD_OUTPUT_HANDLE);
	GetConsoleScreenBufferInfo(ho,&cbi);  
	sz=cbi.dwMaximumWindowSize.X*cbi.dwMaximumWindowSize.Y;
	FillConsoleOutputCharacter(ho,' ',sz,co,&l);
	SetConsoleCursorPosition(ho,co);

#endif _WIN32
}

void clrtoeol(void)
{
#ifndef _WIN32

	kanji_out();
	tputs(CE, 0, _putchar);

#else 

	HANDLE ho;
	DWORD l;
	CONSOLE_SCREEN_BUFFER_INFO cbi;
    COORD      co;
	int sz;

	co.X=0;
	co.Y=0;

	ho=GetStdHandle(STD_OUTPUT_HANDLE);
	GetConsoleScreenBufferInfo(ho,&cbi);  

	sz=(cbi.dwMaximumWindowSize.X)-(cbi.dwCursorPosition.X); 
	FillConsoleOutputCharacter(ho,' ',sz,cbi.dwCursorPosition,&l);

#endif _WIN32

}

#ifndef _WIN32
void getch(void)
{
	kanji_out();
	return getchar();
}
#endif _WIN32

void addch(char ch)
{
#ifndef _WIN32
	static int kanji = 0;
	static int kanji_first = 0;
	static int kanji_skip = 0;

	if (ch == 27) {
		kanji_skip = 2;
		kanji = !kanji;
	}
	else if (kanji_skip) {
		kanji_skip--;
	}
	else if (kanji || (ch & 0x80)) {
		if (kanji_first) {
			kanji_put(kanji_first, ch & 0x7f);
			kanji_first = 0;
			curx += 2;
		}
		else {
			kanji_first = ch & 0x7f;
		}
	}
	else {
		switch (ch) {
		      case '\n':
			clrtoeol();
			curx = 0;
			cury++;
			putchar('\r');
			putchar('\n');
			break;
		      case '\r':
			clrtoeol();
			curx = 0;
			cury++;
			putchar('\r');
			break;
		      case 'H'-'@':
			if (curx > 0) {
				curx--;
				putchar(ch);
			}
			break;
		      default:
			if (ch >= ' ') {
				kanji_out();
				putchar(ch);
				curx++;
			}
			break;
		}
	}
#else
	switch (ch) {
	  case '\n':
		clrtoeol();
		putchar('\n');
		break;
      case '\r':
		clrtoeol();
		putchar('\r');
		break;
	default:
		putchar(ch);
		break;
	}
#endif _WIN32
}

void flash(void)
{
#ifndef _WIN32
	kanji_out();
	if (VB) {
		tputs(VB, 0, _putchar);
	}
	else {
		putchar('G'-'@');
		fflush(stdout);
	}
#endif
}

#endif	NO_CURSES


#ifdef _WIN32

void alarm(int i){
	while(i--)printf("\a");
}
void sleep(int i){
	int j;
	j=time(NULL);
	while(time(NULL)<i+j)Sleep(50);
}

#endif _WIN32